﻿'Option Strict On
'Option Explicit On

Imports System.Data.SqlClient
Imports ContactManager.DataModels
Imports System.Data.SqlServerCe

Namespace DAL

    Friend Class ConnectionString
        Friend Shared ReadOnly CN As String = My.MySettings.Default.ContactsConnectionString
    End Class

    Public Class ContactData

    Public Function GetContacts() As List(Of Contact)

            Dim contacts As New List(Of Contact)
            Dim connection As New SqlCeConnection(ConnectionString.CN)

        Try

                Dim selectStatement As String = "SELECT ContactID, Address, Birthdate, City, MobilePhone, EmailName, FirstName,"
                selectStatement &= " LastName, HomePhone, Notes, StateOrProvince, tblContacts.ContactTypeID as ContactTypeID, WorkPhone, PostalCode, "
                selectStatement &= " tblContactTypes.ContactType as ContactType FROM tblContacts INNER JOIN tblContactTypes ON tblContacts.ContactTypeID=tblContactTypes.ContactTypeID"

                Dim command As New SqlCeCommand(selectStatement, connection)

            connection.Open()
            Dim rdr As SqlCeDataReader = command.ExecuteReader(CommandBehavior.CloseConnection)

            While rdr.Read
                    Dim c As New DataModels.Contact

                    c.ContactID = rdr("ContactID")
                    c.Address = rdr("Address")
                    If Not rdr("Birthdate") Is DBNull.Value Then
                        c.Birthdate = rdr("Birthdate")
                    End If
                    c.City = rdr("City")
                    If Not rdr("MobilePhone") Is DBNull.Value Then
                        c.MobilePhone = rdr("MobilePhone")
                    End If
                    If Not rdr("EmailName") Is DBNull.Value Then
                        c.EmailName = rdr("EmailName")
                    End If
                    c.FirstName = rdr("FirstName")
                    c.LastName = rdr("LastName")
                    If Not rdr("HomePhone") Is DBNull.Value Then
                        c.HomePhone = rdr("HomePhone")
                    End If
                    c.PostalCode = rdr("PostalCode")
                    If Not rdr("Notes") Is DBNull.Value Then
                        c.Notes = rdr("Notes")
                    End If
                    c.StateOrProvince = rdr("StateOrProvince")
                    c.ContactTypeID = rdr("ContactTypeID")
                    If Not rdr("WorkPhone") Is DBNull.Value Then
                        c.WorkPhone = rdr("WorkPhone")
                    End If
                    c.PostalCode = rdr("PostalCode")
                    c.ContactType = rdr("ContactType")
                    If Not rdr("Notes") Is DBNull.Value Then
                        c.Notes = rdr("Notes")
                    End If

                    contacts.Add(c)
            End While
                Return contacts

        Catch ex As Exception
            Throw ex

        Finally
            connection.Close()
            connection.Dispose()
        End Try

        End Function

        Public Function GetContact(ByVal id As Integer) As Contact

            Dim connection As New SqlCeConnection(ConnectionString.CN)

            Try

                Dim selectStatement As String = "SELECT ContactID, Address, Birthdate, City, MobilePhone, EmailName, FirstName,"
                selectStatement &= " LastName, HomePhone, Notes, StateOrProvince, tblContacts.ContactTypeID as ContactTypeID, WorkPhone, PostalCode, "
                selectStatement &= " tblContactTypes.ContactType as ContactType FROM tblContacts INNER JOIN tblContactTypes ON tblContacts.ContactTypeID=tblContactTypes.ContactTypeID"
                selectStatement &= " WHERE ContactID=@ContactID"
                Dim command As New SqlCeCommand(selectStatement, connection)

                command.Parameters.AddWithValue("@ContactID", id)

                connection.Open()
                Dim rdr As SqlCeDataReader = command.ExecuteReader(CommandBehavior.CloseConnection)

                Dim contactData As New ContactTypeData
                Dim c As New DataModels.Contact
                While rdr.Read
                    With c
                        .ContactID = rdr("ContactID")
                        .Address = rdr("Address")
                        .Birthdate = rdr("Birthdate")
                        .City = rdr("City")
                        .MobilePhone = rdr("MobilePhone")
                        .EmailName = rdr("EmailName")
                        .FirstName = rdr("FirstName")
                        .LastName = rdr("LastName")
                        .HomePhone = rdr("HomePhone")
                        .Notes = rdr("Notes")
                        .StateOrProvince = rdr("StateOrProvince")
                        .ContactTypeID = rdr("ContactTypeID")
                        .WorkPhone = rdr("WorkPhone")
                        .PostalCode = rdr("PostalCode")
                        .ContactType = rdr("ContactType")
                    End With

                End While
                Return c

            Finally
                connection.Close()
                connection.Dispose()
            End Try
        End Function

        Public Function DeleteContact(ByVal id As Integer) As Integer

            Dim connection As New SqlCeConnection(ConnectionString.CN)
            Try
                Dim deleteStatement As String = "DELETE FROM tblContacts WHERE ContactID=@ContactID"

                Dim command As New SqlCeCommand(deleteStatement, connection)
                command.Parameters.AddWithValue("@ContactID", id)
                connection.Open()

                Dim rowsAffected As Integer = command.ExecuteNonQuery()

                Return rowsAffected

            Finally
                connection.Close()
                connection.Dispose()
            End Try

        End Function

        Public Function InsertContact(ByVal contactToAdd As Contact) As Integer

            Dim connection As New SqlCeConnection(ConnectionString.CN)
            Try
                Dim insertStatement As String = "INSERT INTO Heroes(Name, SecretIdentity,ComicType) "
                insertStatement &= "VALUES(@FirstName,@LastName,@Address,@Birthdate,@City,@MobilePhone,@EmailName,@HomePhone,@Notes,@StateOrProvince,@ContactTypeID,@WorkPhone,@PostalCode)"

                Dim command As New SqlCeCommand(insertStatement, connection)

                command.Parameters.AddWithValue("@FirstName", contactToAdd.FirstName)
                command.Parameters.AddWithValue("@LastName", contactToAdd.LastName)
                command.Parameters.AddWithValue("@Address", contactToAdd.Address)
                command.Parameters.AddWithValue("@Birthdate", contactToAdd.Birthdate)
                command.Parameters.AddWithValue("@City", contactToAdd.City)
                command.Parameters.AddWithValue("@MobilePhone", contactToAdd.MobilePhone)
                command.Parameters.AddWithValue("@EmailName", contactToAdd.EmailName)
                command.Parameters.AddWithValue("@HomePhone", contactToAdd.HomePhone)
                command.Parameters.AddWithValue("@Notes", contactToAdd.Notes)
                command.Parameters.AddWithValue("@StateOrProvince", contactToAdd.StateOrProvince)
                command.Parameters.AddWithValue("@ContactTypeID", contactToAdd.ContactTypeID)
                command.Parameters.AddWithValue("@WorkPhone", contactToAdd.WorkPhone)
                command.Parameters.AddWithValue("@PostalCode", contactToAdd.PostalCode)

                connection.Open()

                command.ExecuteNonQuery()

                Dim selectStatement As String = "SELECT IDENT_CURRENT('Contacts') FROM Contacts"
                Dim selectCommand As New SqlCeCommand(selectStatement, connection)
                Dim newContactID = CInt(selectCommand.ExecuteScalar)
                Return newContactID

            Finally
                connection.Close()
                connection.Dispose()
            End Try

        End Function

        Public Function UpdateContact(ByVal contactToUpdate As DataModels.Contact) As Integer

            Dim connection As New SqlCeConnection(ConnectionString.CN)
            Try
                Dim updateStatement As String = "UPDATE tblContacts SET FirstName=@FirstName, LastName = @LastName, Address = @Address, City = @City, PostalCode = @PostalCode, WorkPhone = @WorkPhone, HomePhone = @HomePhone, MobilePhone = @MobilePhone, EmailName = @EmailName, Birthdate = @Birthdate, ContactTypeID = @ContactTypeID, Notes = @Notes WHERE ContactID=@ContactID"

                Dim command As New SqlCeCommand(updateStatement, connection)
                command.Parameters.AddWithValue("@ContactID", contactToUpdate.ContactID)
                command.Parameters.AddWithValue("@FirstName", contactToUpdate.FirstName)
                command.Parameters.AddWithValue("@LastName", contactToUpdate.LastName)
                command.Parameters.AddWithValue("@Address", contactToUpdate.Address)
                command.Parameters.AddWithValue("@Birthdate", contactToUpdate.Birthdate)
                command.Parameters.AddWithValue("@City", contactToUpdate.City)
                command.Parameters.AddWithValue("@MobilePhone", contactToUpdate.MobilePhone)
                command.Parameters.AddWithValue("@EmailName", contactToUpdate.EmailName)
                command.Parameters.AddWithValue("@HomePhone", contactToUpdate.HomePhone)
                command.Parameters.AddWithValue("@Notes", contactToUpdate.Notes)
                command.Parameters.AddWithValue("@StateOrProvince", contactToUpdate.StateOrProvince)
                command.Parameters.AddWithValue("@ContactTypeID", contactToUpdate.ContactTypeID)
                command.Parameters.AddWithValue("@WorkPhone", contactToUpdate.WorkPhone)
                command.Parameters.AddWithValue("@PostalCode", contactToUpdate.PostalCode)

                connection.Open()

                Dim rowsAffected As Integer = command.ExecuteNonQuery()

                Return rowsAffected

            Finally
                connection.Close()
                connection.Dispose()
            End Try

        End Function

    End Class

    Public Class ContactTypeData

        Public Function GetContactTypes() As List(Of ContactType)

            Dim contactTypes As New List(Of ContactType)
            Dim connection As New SqlCeConnection(ConnectionString.CN)

            Try

                Dim selectStatement As String = "SELECT ContactTypeID, ContactType FROM tblContactTypes"
                Dim command As New SqlCeCommand(selectStatement, connection)
                connection.Open()
                Dim rdr As SqlCeDataReader = command.ExecuteReader(CommandBehavior.CloseConnection)

                While rdr.Read
                    Dim c As New DataModels.ContactType

                    c.ContactTypeID = rdr("ContactTypeID")
                    c.ContactType = rdr("ContactType")

                    contactTypes.Add(c)
                End While

                Return contactTypes

            Catch ex As Exception
                Throw ex

            Finally
                connection.Close()
                connection.Dispose()
            End Try

        End Function

        Public Function GetContactType(ByVal id As Integer) As ContactType

            Dim connection As New SqlCeConnection(ConnectionString.CN)

            Try

                Dim selectStatement As String = "SELECT * FROM ContactTypes WHERE ID=@ContactTypeID"
                Dim command As New SqlCeCommand(selectStatement, connection)

                Dim adpt As New SqlCeDataAdapter(command)
                command.Parameters.AddWithValue("@ContactTypeID", id)

                connection.Open()
                Dim rdr As SqlCeDataReader = command.ExecuteReader(CommandBehavior.CloseConnection)
                Dim c As New DataModels.ContactType
                While rdr.Read
                    With c
                        .ContactTypeID = rdr("ContactTypeID")
                        .ContactType = rdr("ContactType")
                    End With

                End While
                Return c

            Finally
                connection.Close()
                connection.Dispose()
            End Try
        End Function

        Public Function InsertContactType(ByVal contactTypeToAdd As ContactType) As Integer

        End Function

        Public Function UpdateContactType(ByVal contactTypeToUpdate) As Integer

        End Function

    End Class

End Namespace
